# Station Struct Reference

Station data structure. More...

`#include <station_base.h>`

Inheritance diagram for Station:

## Public Member Functions
RoadStop * | GetPrimaryRoadStop (RoadStopType type) const
RoadStop * | GetPrimaryRoadStop (const struct RoadVehicle *v) const
const AirportFTAClass * | Airport () const
const AirportSpec * | GetAirportSpec () const
| Station (TileIndex tile=INVALID_TILE)
| ~Station ()
| Clean up a station by clearing vehicle orders and invalidating windows.
void | AddFacility (StationFacility new_facility_bit, TileIndex facil_xy)
| Called when new facility is built on the station.
void | MarkTilesDirty (bool cargo_change) const
| Marks the tiles of the station as dirty.
void | UpdateVirtCoord ()
| Update the virtual coords needed to draw the station sign.
uint | GetPlatformLength (TileIndex tile, DiagDirection dir) const
| Determines the REMAINING length of a platform, starting at (and including) the given tile.
uint | GetPlatformLength (TileIndex tile) const
| Obtain the length of a platform.
void | RecomputeIndustriesNear ()
| Recomputes Station::industries_near, list of industries possibly accepting cargo in station's catchment radius.
uint | GetCatchmentRadius () const
| Determines the catchment radius of the station.
Rect | GetCatchmentRect () const
| Determines catchment rectangle of this station.
FORCEINLINE bool | TileBelongsToRailStation (TileIndex tile) const
| Check whether a specific tile belongs to this station.
FORCEINLINE bool | TileBelongsToAirport (TileIndex tile) const
FORCEINLINE TileIndex | GetHangarTile (uint hangar_num) const
uint32 | GetNewGRFVariable (const ResolverObject *object, byte variable, byte parameter, bool *available) const
void | GetTileArea (TileArea *ta, StationType type) const
| Get the tile area for a given station type.
## Static Public Member Functions
static void | RecomputeIndustriesNearForAll ()
| Recomputes Station::industries_near for all stations.
## Data Fields
RoadStop * | bus_stops
| All the road stops.
TileArea | bus_station
| Tile area the bus 'station' part covers.
RoadStop * | truck_stops
| All the truck stops.
TileArea | truck_station
| Tile area the truck 'station' part covers.
TileIndex | airport_tile
| The location of the airport.
TileIndex | dock_tile
| The location of the dock.
IndustryType | indtype
| Industry type to get the name from.
StationHadVehicleOfTypeByte | had_vehicle_of_type
byte | time_since_load
byte | time_since_unload
byte | airport_type
uint64 | airport_flags
| stores which blocks on the airport are taken. was 16 bit earlier on, then 32
byte | last_vehicle_type
std::list< Vehicle * > | loading_vehicles
GoodsEntry | goods [NUM_CARGO]
| Goods at this station.
uint32 | always_accepted
| Bitmask of always accepted cargo types (by houses, HQs, industry tiles when industry doesn't accept cargo).
IndustryVector | industries_near
| Cached list of industries near the station that can accept cargo,.

## Detailed Description

Station data structure.

Definition at line 51 of file station_base.h.

## Constructor & Destructor Documentation

Station::~Station | ( |  | ) |

Clean up a station by clearing vehicle orders and invalidating windows.

Aircraft-Hangar orders need special treatment here, as the hangars are actually part of a station (tiletype is STATION), but the order type is OT_GOTO_DEPOT.

Definition at line 60 of file station.cpp.

References GoodsEntry::cargo, Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tcache, Tzero >::PoolItem<&_station_pool >::CleaningPool(), DeleteStationNews(), DeleteWindowById(), goods, Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tcache, Tzero >::PoolItem<&_station_pool >::index, CargoPacket::InvalidateAllFrom(), InvalidateWindowData(), Aircraft::IsNormalAircraft(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tcache, Tzero >::PoolItem<&_company_pool >::IsValidID(), ViewportSign::MarkDirty(), NUM_CARGO, BaseStation::owner, RemoveOrderFromAllVehicles(), BaseStation::sign, CargoList< Tinst >::Truncate(), VEH_AIRCRAFT, VEH_ROAD, VEH_SHIP, and VEH_TRAIN.

## Member Function Documentation

void Station::AddFacility | ( | StationFacility | new_facility_bit,
|  | TileIndex | facil_xy |
| ) |  |  |

Called when new facility is built on the station.

If it is the first facility it initializes also 'xy' and 'random_bits' members

Definition at line 143 of file station.cpp.

References _date, BaseStation::build_date, FACIL_NONE, BaseStation::facilities, BaseStation::owner, BaseStation::random_bits, and BaseStation::xy.

Referenced by CmdBuildAirport(), CmdBuildDock(), CmdBuildRailStation(), and CmdBuildRoadStop().

uint Station::GetCatchmentRadius | ( |  | ) | const

Determines the catchment radius of the station.

Returns:
  The radius

Definition at line 221 of file station.cpp.

References _settings_game, airport_tile, bus_stops, CA_BUS, CA_DOCK, CA_NONE, CA_TRAIN, CA_TRUCK, CA_UNMODIFIED, AirportSpec::catchment, dock_tile, INVALID_TILE, StationSettings::modified_catchment, GameSettings::station, TileArea::tile, BaseStation::train_station, and truck_stops.

Referenced by FindStationsAroundTiles(), GetCatchmentRect(), and UpdateStationAcceptance().

Rect Station::GetCatchmentRect | ( |  | ) | const

Determines catchment rectangle of this station.

Returns:
  clamped catchment rectangle

Definition at line 244 of file station.cpp.

References GetCatchmentRadius(), MapMaxX(), MapMaxY(), and BaseStation::rect.

Referenced by CheckSubsidised(), and RecomputeIndustriesNear().

uint Station::GetPlatformLength | ( | TileIndex | tile | ) | const`[virtual]`

Obtain the length of a platform.

Precondition:
  tile must be a rail station tile

Parameters:

  | tile | A tile that contains the platform in question

Returns:
  The length of the platform

Implements BaseStation.

Definition at line 181 of file station.cpp.

References AXIS_X, GetRailStationAxis(), IsCompatibleTrainStationTile(), TileBelongsToRailStation(), and TileDiffXY().

uint Station::GetPlatformLength | ( | TileIndex | tile,
|  | DiagDirection | dir |
| ) |  |  | const`[virtual]`

Determines the REMAINING length of a platform, starting at (and including) the given tile.

Parameters:

  | tile | the tile from which to start searching. Must be a rail station tile
  | dir | The direction in which to search.

Returns:
  The platform length

Implements BaseStation.

Definition at line 203 of file station.cpp.

References DIAGDIR_END, IsCompatibleTrainStationTile(), IsRailStationTile(), and TileOffsByDiagDir().

Referenced by GetTrainStopLocation(), LoadUnloadVehicle(), and NPFSaveTargetData().

void Station::GetTileArea | ( | TileArea * | ta,
|  | StationType | type |
| ) |  |  | const`[virtual]`

Get the tile area for a given station type.

Parameters:

  | ta | tile area to fill.
  | type | the type of the area

Implements BaseStation.

Definition at line 377 of file station_cmd.cpp.

References airport_tile, bus_station, dock_tile, TileArea::h, AirportSpec::size_x, AirportSpec::size_y, TileArea::tile, BaseStation::train_station, truck_station, and TileArea::w.

FORCEINLINE bool Station::TileBelongsToRailStation | ( | TileIndex | tile | ) | const`[inline, virtual]`

Check whether a specific tile belongs to this station.

Parameters:

  | tile | the tile to check

Returns:
  true if the tile belongs to this station

Implements BaseStation.

Definition at line 119 of file station_base.h.

References GetStationIndex(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tcache, Tzero >::PoolItem<&_station_pool >::index, and IsRailStationTile().

Referenced by FloodVehicles(), AIOrder::GetOrderDestination(), GetPlatformLength(), and MarkTilesDirty().

## Field Documentation

IndustryVector Station::industries_near

Cached list of industries near the station that can accept cargo,.

See also:
  DeliverGoodsToIndustry()

Definition at line 95 of file station_base.h.

Referenced by CheckSubsidised(), DeliverGoodsToIndustry(), and RecomputeIndustriesNear().

The documentation for this struct was generated from the following files:

- src/station_base.h
- src/newgrf_station.cpp
- src/station.cpp
- src/station_cmd.cpp